/*
    CaPriCe Forever - Amstrad CPC 464/664/6128 emulator
    Copyright (C) 2014-2018 by Frdric Coste

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#ifndef Z80DASM_H
#define Z80DASM_H

#include "..\..\Engine\types.h"
#include "..\..\Engine\Native_CPC.h"

#ifdef __cplusplus
extern "C" {
#endif


typedef tUChar (*TZ80dasmReadFuntion)(tNativeCPC* NativeCPC, tULong addr);


typedef struct
{
  char MachineCode[30];
  char Instruction[30];
  char MemoryContent[30];
  tNativeCPC* NativeCPC;
  TZ80dasmReadFuntion ReadFunction;
  tULong StartAddress;
  tUChar DummyZ80;
} TZ80dasmParam;


extern tULong Z80dasmDecodeInstruction(tULong addr, TZ80dasmParam* Param);

#ifdef __cplusplus
}  /* End of the 'extern "C"' block */
#endif

#endif /* ! Z80DASM_H */
