/*
    CaPriCe Forever - Amstrad CPC 464/664/6128 emulator
    Copyright (C) 2015-2019 by Frdric Coste

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "..\Native_CPC.h"


/*
** Make sure we can call this stuff from C++.
*/
#ifdef __cplusplus
extern "C" {
#endif


//===================
// PATCH begin
#ifdef _PATCH_ENABLE

#endif /* _PATCH_ENABLE */
// PATCH end
//===================


extern tULong AMSDOS_DiskAutoStart(tDiskOperation* DiskOperation);
extern tULong ROMDOS_DiskAutoStart(tDiskOperation* DiskOperation);


tULong Native_DiskAutoStart(tDiskOperation* DiskOperation)
/***********************************************************************
 *
 *  Native_DiskAutoStart
 *
 ***********************************************************************/
{
tULong ReturnCode;

  // Detect format type
  if (DiskOperation->FormatType == DISK_FORMAT_UNKNOWN)
  {
    Native_DiskFormatType(DiskOperation);
  }

  switch (DiskOperation->FormatType)
  {
    // ROMDOS
    case DISK_FORMAT_ROMDOS_D10:
    case DISK_FORMAT_ROMDOS_D1:
    {
	    ReturnCode = ROMDOS_DiskAutoStart(DiskOperation);
    }
    break;

	  // AMSDOS
	  default:
	    ReturnCode = AMSDOS_DiskAutoStart(DiskOperation);
  }

  return ReturnCode;
}
/*----------------------------------------------------------------------------*/


#ifdef __cplusplus
}  /* End of the 'extern "C"' block */
#endif
