/*
    CaPriCe Forever - Amstrad CPC 464/664/6128 emulator
    Copyright (C) 2015-2019 by Frdric Coste

    This program is free software: you can redistribute it and/or modify
    it under the terms of the GNU General Public License as published by
    the Free Software Foundation, either version 3 of the License, or
    (at your option) any later version.

    This program is distributed in the hope that it will be useful,
    but WITHOUT ANY WARRANTY; without even the implied warranty of
    MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
    GNU General Public License for more details.

    You should have received a copy of the GNU General Public License
    along with this program.  If not, see <http://www.gnu.org/licenses/>.
*/


#include "..\Native_CPC.h"


/*
** Make sure we can call this stuff from C++.
*/
#ifdef __cplusplus
extern "C" {
#endif


//===================
// PATCH begin
#ifdef _PATCH_ENABLE

#endif /* _PATCH_ENABLE */
// PATCH end
//===================



#define FILE_ENTRY_SIZE                32


tBool ROMDOS_DiskAddBlockToCatEntry(tDiskOperation* DiskOperation, tULong Block)
/***********************************************************************
 *
 *  ROMDOS_DiskAddBlockToCatEntry
 *
 ***********************************************************************/
{
tBool AddOK = cFalse;
tUChar loopBlock;
tUChar* EntryP;

  EntryP = DiskOperation->CurrentCatEntryP;
  for (loopBlock=0; loopBlock < 16; loopBlock+=2)
  {
    if ( (EntryP[0x10+loopBlock] == 0) && (EntryP[0x11+loopBlock] == 0) ) 
    {
      EntryP[0x10 + loopBlock] = (tUChar)((Block >> 0) & 0xff);
      EntryP[0x11 + loopBlock] = (tUChar)((Block >> 8) & 0xff);
      AddOK = cTrue;
      break;
    }
  } 

  return (AddOK);
}
/*----------------------------------------------------------------------------*/

#ifdef __cplusplus
}  /* End of the 'extern "C"' block */
#endif
